//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 静的変形メッシュコリジョン実装
 * @author Junpee
 */

#include "LampBasic.h"
#include "Collision/Leaf/StaticDeformedMeshCollision.h"
#include "Collision/System/CollisionScene.h"
#include "Collision/System/CollisionNode.h"
#include "Collision/Leaf/StaticSphereCollision.h"

namespace Lamp{

//------------------------------------------------------------------------------
// 生成、破棄
//------------------------------------------------------------------------------
// コンストラクタ
StaticDeformedMeshCollision::StaticDeformedMeshCollision(
	const String& name, CollisionScene* scene) :
	StaticCollisionLeaf(name, scene), worldMeshChanged_(true){
}
//------------------------------------------------------------------------------
// デストラクタ
StaticDeformedMeshCollision::~StaticDeformedMeshCollision(){
}
//------------------------------------------------------------------------------
// コピー
//------------------------------------------------------------------------------
// 静的変形メッシュコリジョンのコピー
StaticDeformedMeshCollision*
	StaticDeformedMeshCollision::copyStaticDeformedMeshCollision() const{
	StaticDeformedMeshCollision* destination =
		getScene()->createStaticDeformedMeshCollision(
		getScene()->renameLeaf(getName()));
	// 静的コリジョンリーフの値をコピー
	copyStaticCollisionLeafValue(destination);
	// メンバのコピー
	destination->mesh_ = mesh_;
	destination->worldMesh_ = worldMesh_;
	Assert(destination->worldMeshChanged_);
	return destination;
}
//------------------------------------------------------------------------------
// 交差
//------------------------------------------------------------------------------
// 球交差
void StaticDeformedMeshCollision::intersection(
	IntersectionResult* result, const Sphere& sphere, u_int collisionMask){
	// グローバルでの有効、無効判定
	if(!isGlobalEnabled()){ return; }
	// コリジョンマスク判定
	if((getCollisionMask() & collisionMask) == 0){ return; }
	// バウンディング判定
	if(!worldMesh_.intersectBounding(sphere)){ return; }
	// メッシュ判定、ワールドメッシュの算出も行う
	getWorldMesh().intersectMesh(result, sphere);
}
//------------------------------------------------------------------------------
// 球コリジョン交差
void StaticDeformedMeshCollision::intersection(IntersectionResult* result,
	StaticSphereCollision* sphere, u_int collisionMask){
	// グローバルでの有効、無効判定
	if(!isGlobalEnabled()){ return; }
	// コリジョンマスク判定
	if((getCollisionMask() & collisionMask) == 0){ return; }
	// バウンディング判定
	const Sphere& worldSphere = sphere->getWorldSphere();
	if(!worldMesh_.intersectBounding(worldSphere)){ return; }
	// メッシュ判定
	if(isScaled()){
		// スケールありの場合はワールドメッシュを算出して交差
		getWorldMesh().intersectMesh(result, worldSphere);
	}else{
		// スケール無しの場合は球をローカル座標に持ってきて交差
		Matrix34 matrix;
		getWorldMatrix().invertTransformation(&matrix);
		Sphere localSphere = worldSphere.transform(matrix);
		getMesh().intersectMesh(result, localSphere);
	}
}
//------------------------------------------------------------------------------
// 走査
//------------------------------------------------------------------------------
// 走査
void StaticDeformedMeshCollision::traverseImplement(
	const Matrix34& parentMatrix, bool parentEnabled, bool parentScaled,
	bool parentChanged){
	// 走査のセットアップ
	if(!traverseSetup(parentEnabled, parentChanged)){ return; }

	// ワールドバウンディングの構築
	if(parentScaled){
		// スケール入りバウンディング
		worldMesh_.setBoundingBox(
			mesh_.getBoundingBox().transform(parentMatrix));
		worldMesh_.setBoundingSphere(
			mesh_.getBoundingSphere().scaledTransform(parentMatrix));
	}else{
		// スケール無しバウンディング
		worldMesh_.setBoundingBox(
			mesh_.getBoundingBox().transform(parentMatrix));
		worldMesh_.setBoundingSphere(
			mesh_.getBoundingSphere().transform(parentMatrix));
	}

	// ワールドメッシュ変更フラグを立てる
	worldMeshChanged_ = true;

	// ツリーへの挿入、またはツリー内の移動
}
//------------------------------------------------------------------------------
// メッシュ
//------------------------------------------------------------------------------
// ワールドメッシュの取得
const DeformedMeshGeometry& StaticDeformedMeshCollision::getWorldMesh(){
	// 有効でないとワールドメッシュは生成されない
	Assert(isGlobalEnabled());

	// ワールドメッシュに変更がなければそのまま返す
	if(!worldMeshChanged_){ return worldMesh_; }
	// ワールドメッシュ変更フラグのクリア
	worldMeshChanged_ = false;

	// トランスフォーム
	Assert(getParent() != NULL);
	const Matrix34& matrix = getParent()->getWorldMatrix();
	int triangleCount = mesh_.getTriangleCount();
	for(int i = 0; i < triangleCount; i++){
		worldMesh_.setTriangle(i, mesh_.getTriangle(i).transform(matrix));
	}
	return worldMesh_;
}
//------------------------------------------------------------------------------
} // End of namespace Lamp
//------------------------------------------------------------------------------
